/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define _FIG_AND_TITLE   "_FIG_AND_TITLE"

/* (1) ]p̃f[^\` */
typedef struct {
    char figure[24];
    char title[100];
} FigAndTitle;

static void CopyCB();
static void PasteCB();
static Widget box, figure, title;
static Pixmap pixmap;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Clip2type", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* Gƃx͂ޔ */
    ac = 0;
    box = XmCreateRowColumn(panel, "box", al, ac);
    XtManageChild(box);
    /* G */
    ac = 0;
    figure = XmCreateLabel(box, "figure", al, ac);
    XtManageChild(figure);
    /* x */
    ac = 0;
    title = XmCreateLabel(box, "title", al, ac);
    XtManageChild(title);

    /* [Rs[] --> Nbv{[hɃf[^Rs[ */
    ac = 0;
    copy = XmCreatePushButton(panel, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, NULL);
    XtManageChild(copy);

    /* [y[Xg] --> Nbv{[hf[^o */
    ac = 0;
    paste = XmCreatePushButton(panel, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);
    XtManageChild(paste);

    /* (2) VtH[}bgo^ */
    if (XmClipboardRegisterFormat(XtDisplay(toplevel), _FIG_AND_TITLE, 8)
                                                        != ClipboardSuccess) {
        fprintf(stderr, "Cannot register format %s\n", _FIG_AND_TITLE);
        exit(1);
    }

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* [Rs[] {^̃R[obN */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    FigAndTitle fig_title;
    XmString label;
    long item_id;
    static int private_id = 0;
    long data_id;
    XmString string;
    char *text;

    /* figure G (sbNX}bv) o */
    XtVaGetValues(figure, XmNlabelPixmap, &pixmap, NULL);

    /* title 烉xo */
    XtVaGetValues(title, XmNlabelString, &string, NULL);
    XmStringGetLtoR(string, XmFONTLIST_DEFAULT_TAG, &text);
    XmStringFree(string);

    /* sbNX}bvx̏񂪎ȂƃG[ */
    if (pixmap == XmUNSPECIFIED_PIXMAP || text == NULL) {
        XBell(XtDisplay(w), 0);
        return;
    }

    /* (3) ]f[^ (sbNX}bv ID  16 i̕) */
    sprintf(fig_title.figure, "%x", pixmap);
    strcpy(fig_title.title, text);
    XtFree(text);

    /* KȖOŃRpEhEXgOĂ */
    label = XmStringCreateLocalized("_my_data");

    /* Nbv{[hւ̃Rs[Jn */
    if (XmClipboardStartCopy(XtDisplay(box), XtWindow(box), label,
                             XtLastTimestampProcessed(XtDisplay(box)),
                             NULL, NULL, &item_id) != ClipboardSuccess) {
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        return;
    }
    /* (4) Nbv{[hɃsbNX}bvƃ^CgRs[ */
    if (XmClipboardCopy(XtDisplay(box), XtWindow(box), item_id,
                        _FIG_AND_TITLE, &fig_title, sizeof(fig_title),
                        private_id, &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(text), XtWindow(text), item_id);
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        return;
    }
    /* Nbv{[hւ̃Rs[I (ۂɃf[^]) */
    if (XmClipboardEndCopy(XtDisplay(box), XtWindow(box), item_id)
                                                         != ClipboardSuccess) {
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        return;
    }
    private_id++;
    XmStringFree(label);
}

/* [y[Xg] {^̃R[obN */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    FigAndTitle fig_title;
    unsigned long num_bytes;
    long private_id;
    XmString string;

    /* (5) Nbv{[hsbNX}bvƃ^Cgo */
    if (XmClipboardRetrieve(XtDisplay(box), XtWindow(box),
                   _FIG_AND_TITLE, &fig_title, sizeof(fig_title), &num_bytes,
                   &private_id) != ClipboardSuccess || num_bytes == 0) {
        XBell(XtDisplay(w), 0);
        return;
    }

    /* osbNX}bv figure ɕ\ */
    sscanf(fig_title.figure, "%x", &pixmap);
    XtVaSetValues(figure, XmNlabelPixmap, pixmap, NULL);

    /* o title ɕ\ */
    string = XmStringCreateLocalized(fig_title.title);
    XtVaSetValues(title, XmNlabelString, string, NULL);
    XmStringFree(string);
}
